# Generated by Django 3.0.8 on 2022-03-17 17:13

from django.db import migrations
import os
import sys


class DryRunException(Exception):
    pass

def set_old_rotation_point(apps, schema_editor):
    do_migration = os.environ.get('MIGRATE') == 'True'

    print()
    print("MIGRATE=" + str(os.environ.get('MIGRATE')))

    # use the historical model
    Fragment = apps.get_model('rooms', 'Fragment')

    # number of fragments to be updated
    count = 0
    # connect unique lines that trigger migration
    migration_lines = set()
    for fragment in Fragment.objects.all():
        script = fragment.userscript.get('scriptSourceString')
        if script is not None:
            # set 0, 0 as default rotation points for all fragments that
            # have 'rotation' in their user script
            # we actually would like to set 0, 0 for all fragments that
            # change the fragment's rotation property in their user script,
            # and this way we might also catch 'rotation' as variable name,
            # or in comments, but this should be okay, if we check the lines
            # that contain rotation (if not too many)
            if 'rotation' in script:
                count += 1
                fragment.relative_rotation_point_x = 0.0
                fragment.relative_rotation_point_y = 0.0

                # get individual lines and print if they contain 'rotation'
                lines = script.split('\n')
                for line in lines:
                    if 'rotation' in line:
                        migration_lines.add(line)
                if do_migration:
                    # only update necessary fields
                    fragment.save(update_fields=[
                        'relative_rotation_point_x', 'relative_rotation_point_y'])

    print()
    print('----------------')
    print('migration lines:')
    print('----------------')
    for line in migration_lines:
        print(line)
    print('----------------')
    print()

    if do_migration:
        print('updated fragments: ' + str(count))
    if not do_migration:
        print('fragments to update: ' + str(count))
        # abort the migration, it will not be marked as migrated
        # no stack trace desired here!
        sys.tracebacklimit=0
        raise DryRunException(
                '\n  WARNING: This was a TEST RUN.' +
                '\n    Set MIGRATE=True in your'
                '\n    environment to migrate'
                )

class Migration(migrations.Migration):

    dependencies = [
        ('rooms', '0037_add_rotation_points_20220406_1850'),
    ]

    operations = [
        # this is not reversible, because we don't know what happened
        # due to user input
        # add noop to allow rollbacks
        # migrations.RunPython(
            # migrations.RunPython.noop,
            # reverse_code=migrations.RunPython.noop),
    ]
